clear all

plot_freq = 0;
plot_SNR  = 0;
plot_IR   = 1;
plot_SIM  = 0;
plot_SvsM = 0;

for kk = 400:400
for jj = 0:2
for ii = 1:8
    
    % Tellere
    II = int2str(ii + 8*jj);
    JJ = int2str(jj + 1);
    MM = int2str(jj*90);
    NN = int2str(ii);
    KK = int2str(kk);
    %% Leser inn data
    % Simuleringer
    if ii == 1 && jj == 0
        SIM = zeros(24,8);
        load('Sim_data\Sim_testing\fcenter.mat')
    end
    eval(['sim = load(''Sim_data\Sim_testing\',MM,'_',NN,'_',KK,'.mat'');'])
    SIM(ii+8*jj,:) = sim.L1;
    
    % Mledata (Testmlinger)
    eval(['[AA, Fs1] = loadimp(''Testmaalinger\Meas_',II,'.wmb'');']);
    
    if ii == 1
        eval(['REF_meas0 = loadimp(''Testmaalinger\Meas_',II,'.wmb'');']);    
        Noise0 = loadimp('Testmaalinger\noise.wmb');
    end
        
    
    % Tidsvindu
    win1 = [4471 4099 3829 3681 3332 2662 2205 1582];
    win2 = [3500 3389 2762 2308 2351 2329 2119 1723];
    win3 = [4471 3801 3817 3703 3947 3316 2694 1517];
   
    eval(['win = win',JJ,';']);
    
    [~,locs1] = findpeaks(AA, 'SORTSTR', 'descend');    
    [~,locs2] = findpeaks(REF_meas0, 'SORTSTR', 'descend');    

    
    % Ptrykker tidsvindu
    A = AA(locs1(1)-10:locs1(1)+win(ii)-10);
    REF_meas = REF_meas0(locs2(1)-10:105+win(2)-10);  
%     plot(REF_meas)
%     pause 
    Noise = Noise0(1:win(ii));
        
    % FFT
    L1 = length(A);
    NFFT1 = 2^(nextpow2(L1)+5);
    
    F1 = fft(A, NFFT1)/L1;
    F1 = F1(1:NFFT1/2+1).^2;
    
    F2 = fft(REF_meas, NFFT1)/L1;
    F2 = F2(1:NFFT1/2+1).^2;
    
    F3 = fft(Noise, NFFT1)/L1;
    F3 = F3(1:NFFT1/2+1).^2;
    %% Smoothing
%     octfrac = 3;
%     fstart = 100;
%     fend = 19953;
%     npoints = 24;
    
    octfrac = 1;
    fstart = 121;
    fend = 15447;
    npoints = 8;
    
    fvec1 = Fs1/2*linspace(0,1,NFFT1/2+1);
    
    [F1out,fvecout] = F2smospanew(fvec1,F1,octfrac,fstart,fend,npoints);
    [F2out]         = F2smospanew(fvec1,F2,octfrac,fstart,fend,npoints);
    [F3out]         = F2smospanew(fvec1,F3,octfrac,fstart,fend,npoints);
    
    % dB
    F1 = 10*log10(F1out/((20*10^-6)));
    F2 = 10*log10(F2out/((20*10^-6)));
    F3 = 10*log10(F3out/((20*10^-6)));
    
    if ii == 1 && jj == 0
        FR1 = zeros(npoints,24);
        FR2 = zeros(npoints,24);
        FR3 = zeros(npoints,24);
    end
    
    FR1(:,ii + 8*jj) = F1;
    FR2(:,ii + 8*jj) = F2;
    FR3(:,ii + 8*jj) = F3;
    
    % Plot 
    %% IR Mlinger
    if plot_IR == 1        
               
        plot(AA(locs1-10:end))
        hold on
        plot(A, 'r')
        
        grid on
        hold off
        
%         xlim([0 200])
        xlim([0000 6000])
%         ylim([-3 3].*10^-2)

        xlabel('Samples [Hz]')
        ylabel('Magnitude [dB]')
        
        JJ = num2str(ii*2-1);
        eval(['title(''Avstand - ',JJ,'m'')']);
       
        pause        
    end
    
end
end
end

    %% Setter ref 0 dB (ikke tilfelle atm)
    maxFR1 = sort(max(FR1),'descend');
    FR1N  = FR1+20;%  - maxFR1(1);
    
    maxSIM = sort(max(SIM),'descend');
    SIMN = SIM-100;% - maxSIM(1);
 
    %% Freq
for ii = 1:8
    if plot_freq == 1
    
        figure(1)
        semilogx(fvecout, FR1N(:,ii + 8*0), '-ob')
        hold on
        semilogx(fvecout, FR1N(:,ii + 8*1), '-or')
        semilogx(fvecout, FR1N(:,ii + 8*2), '-og')
        
        grid on
        hold off

        axis([0 8000 -65 5])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')

        JJ = num2str(ii*2 - 1);
        title(['Meas: Avstand - ' JJ ' m'])

        legend(['Mling 0' char(176)], ['Mling 90' char(176)], ['Mling 180' char(176)], ...
            'Location','SouthWest')
        
        if ii == 1
            Diff_rot = zeros(3,8);
        end
        
        Diff_rot(1,ii) = mean(FR1N(:,ii + 8*0));
        Diff_rot(2,ii) = mean(FR1N(:,ii + 8*1));
        Diff_rot(3,ii) = mean(FR1N(:,ii + 8*2));
        
        if ii == 8
            plot([1:2:15], Diff_rot, '-o')
            
            axis([0 15 -30 0])
            xlabel('Dist. [m]')
            ylabel('Magnitude [dB]')
            title('Mean Magnitude as function of distance')
            
            hold on
            test = 20*log10((1./[1:2:15])/((20*10^-6)));
            plot([1:2:15], test-94, '--+')
            plot([1:2:15], test-104, '--+g')
            plot([1:2:15], test-112, '--+r')
            
            grid on
            
            legend(['Mling 0' char(176)], ['Mling 90' char(176)], ['Mling 180' char(176)], ...
            '1/r - 47 dB', '1/r - 57 dB', '1/r - 65 dB', 'Location','NorthEast')
        end

        pause
    end
    
    %% SNR
    if plot_SNR == 1
        figure(2)

        semilogx(fvecout, FR1(:,ii + 8*0) - FR3(:,ii + 8*0), '-ob')
        hold on
        semilogx(fvecout, FR1(:,ii + 8*1) - FR3(:,ii + 8*1), '-or')
        semilogx(fvecout, FR1(:,ii + 8*2) - FR3(:,ii + 8*2), '-og')

        grid on
        hold off

        axis([0 5000 -10 70])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')

        JJ = num2str(ii*2 - 1);
        title(['Meas: Avstand - ' JJ ' m'])

        legend(['SNR 0' char(176)], ['SNR 90' char(176)], ['SNR 180' char(176)], ...
            'Location','NorthWest')
        
        pause
    end

    %% SIM
    if plot_SIM == 1
        figure(3)
        semilogx(fcenter,SIMN(ii + 8*0,:), '--ob')
        hold on
        grid on
        semilogx(fcenter,SIMN(ii + 8*1,:), '--or')
        semilogx(fcenter,SIMN(ii + 8*2,:), '--og')
        hold off
        
        axis([0 8000 -65 5])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title('SIM: Direct sound & First reflection')
        
        pause
    end
    
    %% SIM vs Meas. 
    if plot_SvsM == 1
        JJ = num2str(ii*2 - 1);
        
        figure(1)
        semilogx(fvecout, FR1N(:,ii + 8*0), '-ob')
        hold on
        grid on
        semilogx(fcenter,SIMN(ii + 8*0,:), '-or')
        hold off
        
        axis([100 5000 -65 5])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title({'Direct sound & First reflection:', ['Ang: 0 ' ...
            char(176) ', Dist: ' JJ ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
        legend('Meas.', 'Sim.', 'Location', 'SouthWest')
        
        figure(2)
        semilogx(fvecout, FR1N(:,ii + 8*1), '-ob')
        hold on
        grid on
        semilogx(fcenter,SIMN(ii + 8*1,:), '-or')
        hold off
        
        axis([100 5000 -65 5])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title({'Direct sound & First reflection:', ['Ang: 90 ' ...
            char(176) ', Dist: ' JJ ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
        legend('Meas.', 'Sim.', 'Location', 'SouthWest')
        
        figure(3)
        semilogx(fvecout, FR1N(:,ii + 8*2), '-ob')
        hold on
        grid on
        semilogx(fcenter,SIMN(ii + 8*2,:), '-or')
        hold off
        
        axis([100 5000 -65 5])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title({'Direct sound & First reflection:', ['Ang: 180 ' ...
            char(176) ', Dist: ' JJ ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
        legend('Meas.', 'Sim.', 'Location', 'SouthWest')
        
        pause     
    end
end     

    
%% Lukk alt 
fopen('all');   % Lister alle pne filer
fclose('all');  % Lukker alle pne filer
% close all       % Lukker alle plot