tic
clear all
warning off

plot_freq = 0;
plot_IR   = 0;

OMNI      = 0;
UNI       = 0;

hoyde     = 0;

save_data       = 1;
festningsparken = 1;
refl_only       = 0;

load('lspdata.mat');

REF_meas = loadimp('Meas_data\2.wmb');
REF_meas = REF_meas(126:485);

% [REF_meas] = loadimp('Festningsparken\serie1\Meas_1.wmb');
% 
% Blp = fir1(5000,[50 7000]./(24000)); % LP-filter
% REF_meas = conv(Blp,REF_meas);
% REF_meas = REF_meas(2456:3363)*1;%00000;

% REF_meas = REF_meas(2456:2801)*1;%00000;

%  REF_meas = REF_meas(100:883);

% [REF_meas] = loadimp('Testmaalinger\Meas_1.wmb');
% Blp = fir1(5000,[50 8000]./(24000)); % LP-filter
% REF_meas = conv(Blp,REF_meas);
% REF_meas = REF_meas(2526:3337);

% plot(REF_meas)
% grid on

Fs = 48000;
C = 344;
Rho = 1.2;
% C = 338;

for R_flow = 550
for mm = 0:2
for nn = 1:7
    MM = int2str(mm*90);
    NN = int2str(nn);
    R_FLOW = int2str(R_flow);
    
    %% Geo-data
    % Posisjoner
    if festningsparken == 1 && hoyde == 0
        dd = [1 3 5 7 9 11 13];   % Festningsparken  
        Xs = [0 0 2.9];           % Kilde [x y z]
        Xr = [dd(nn) 0 2.9];      % Mottaker 
    elseif festningsparken == 1 && hoyde == 1
        dd = [2.9 2.4 1.9 1.4 0.9];   % Festningsparken, hyde var.  
        Xs = [0 0 2.9];               % Kilde [x y z]
%         Xr = [5 0 dd(nn)];            % Mottaker, pos. 1
        Xr = [10.3 0 dd(nn)];         % Mottaker, pos. 2
    else
        dd = [1.2 3.2 5.2 7.4 9.4 11.4 13.6 15.6] - 0.38/2; % Utenfor Gml. Elektro
        Xs = [0 0 3.05];                                    % Kilde [x y z]
        Xr = [dd(nn) 0 2.60];                               % Mottaker 
    end
    
    
    Azimuth = 90*mm;   % Benyttes i sted for y-aksen (grader)
    Azimuth = Azimuth*pi/180;
    % Bakkeplanet
    P = [0 0 1 0];
    N = [0 0 1];

    % Speilkilde
    L = abs(dot(N, Xs) + P(4)/sqrt(sum(P(1:3).^2)));
    Xis = Xs - 2*L*N;

    % Refleksjonspunkt
    % T = -(dot(N, Xis) + P(4))/(dot(N, (Xr-Xis)));
    % Xrefl = Xis + T*(Xr - Xis);

    %% IR 
    % Delay & dempning (1/r)
    R1 = sqrt(sum((Xr - Xs).^2));
    R2 = sqrt(sum((Xr - Xis).^2));

    Amp1 = 1/R1;
    Amp2 = 1/R2;
    
    Delay1 = round((R1/C)*Fs);
    Delay2 = round((R2/C)*Fs);

    IR1 = zeros(1,Fs);
    IR2 = zeros(1,Fs);

    if refl_only == 1
        IR1(10) = 0;
        IR2(10+Delay2-Delay1) = Amp2;
    else       
        IR1(10) = Amp1;
        IR2(10+Delay2-Delay1) = Amp2;
    end
    
    if OMNI == 0
% % % % % % % %         IR1 = conv(IR1,REF_meas);
% % % % % % % %         IR2 = conv(IR2,REF_meas);
    end

    T = ((1:length(IR1))/(Fs)*1000);

    %% Vinkel & Direktivitet 
    % Azimuth
    [~, I] = sort(abs(phivec-Azimuth));
    S1 = 1-abs((phivec(I(1))-Azimuth))/abs((phivec(I(2))-phivec(I(1))));

    Direc1 = S1*octlevels(:,I(1)) + (1-S1)*octlevels(:,I(2));

    if mm == 0
        % Direktelyd
        Ang1 = asin(abs(Xr(3)-Xs(3))/R1);

        [~, I] = sort(abs(phivec-Ang1));
        S1 = 1-abs((phivec(I(1))-Ang1))/abs((phivec(I(2))-phivec(I(1))));

        Direc2 = S1*octlevels(:,I(1)) + (1-S1)*octlevels(:,I(2)) + Direc1;

        % Bakkerefleksjon
        Ang2 = asin(abs(Xr(3)-Xis(3))/R2);

        [~, I] = sort(abs(phivec-Ang2));
        S1 = 1-abs((phivec(I(1))-Ang2))/abs((phivec(I(2))-phivec(I(1))));

        Direc3 = S1*octlevels(:,I(1)) + (1-S1)*octlevels(:,I(2)) + Direc1;
        
    elseif mm == 1
        Direc2 = octlevels(:,10);
        Direc3 = octlevels(:,10);
    elseif mm == 2
        Direc2 = octlevels(:,19);
        Direc3 = octlevels(:,19);
    end

    %% Filtrering
    for ii = 1:8
        fcenter = 1000*(2.0).^[-5:2];
        fd = (2^0.5);
        fupper = fcenter.*fd;
        flower = fcenter./fd;

        d = fdesign.octave(1,'Class 2','N,F0',20,fcenter(ii),Fs); 
        validcenterfreq = validfrequencies(d);
        Hd = design(d); 
        % fvtool(Hd,'Fs',48000,'FrequencyScale','log')

        if ii == 1
            y = zeros(length(IR1),8*2);
        end

        y(:,ii+0) = filter(Hd,IR1);
        y(:,ii+8) = filter(Hd,IR2);
    end

    %% Refleksjonstap (bakke)

    if mm == mm(1) && nn == nn(1)
        Zn_DB = zeros(1,8);
        Zn_M  = zeros(1,8);
        Zn_K  = zeros(1,8);
%         R_flow = 900;

        for ii = 1:8
            % Delany-Bazley
            Zn_DB(ii) = 1+9.08*(1*fcenter(ii)/R_flow)^-0.75 ...
                + 1i*11.9*(1*fcenter(ii)/R_flow)^-0.75;
            % Miki
            Zn_M(ii) = 1+5.50*(1*fcenter(ii)/R_flow)^-0.632 ...
                + 1i*8.43*(1*fcenter(ii)/R_flow)^-0.632;
            % Komatsu    
            Zn_K(ii) = 1+0.00027*((2 - log10(fcenter(ii)/(R_flow*1000)))^6.2) ...
                - 1i*0.0047*((2 - log10(fcenter(ii)/(R_flow*1000)))^4.1);
            %Alfa_uni (R_flow = 550)
            Alfa_uni_DB = [0.0959    0.1528    0.2371    0.3538    0.4997    0.6553    0.7886    0.8751];
            Alfa_uni_M  = [0.1470    0.2145    0.3052    0.4197    0.5507    0.6815    0.7910    0.8651];
            Alfa_uni_K  = [0.3551    0.4330    0.5202    0.6124    0.7033    0.7845    0.8482    0.8902];
                
            Zn       = Zn_K;
            Alfa_uni = Alfa_uni_K; 
        end
    end

    if UNI == 1 && mm == mm(1) && nn == nn(1)

        Ang = (0:1:90)*pi/180;

        R_ground = zeros(1,8);

        for ii = 1:8%length(fcenter)
            Zeta0 = 1+9.08*(1*fcenter(ii)/R_flow)^-0.75 ...
                            + 1i*11.9*(1*fcenter(ii)/R_flow)^-0.75;

            Zeta1 = 1+5.50*(1*fcenter(ii)/R_flow)^-0.632 ...
                            + 1i*8.43*(1*fcenter(ii)/R_flow)^-0.632;


            Zeta2 = 1+0.00027*((2 - log10(fcenter(ii)/(R_flow*1000)))^6.2) ...
                        - 1i*0.0047*((2 - log10(fcenter(ii)/(R_flow*1000)))^4.1);
            %%% !!! %%%
            Zn = Zeta2;        
            %%% !!! %%%
            
%             fun = @(Ang) (4*real(Zeta).*cos(Ang)) ./ ((abs(Zeta).*cos(Ang)).^2 + 2*real(Zeta).*cos(Ang) + 1).*sin(2*Ang);
            
            fun = @(Ang) (cos(Ang)-1./Zn)./(cos(Ang)+1./Zn);
            
            R_ground(1,ii) = integral(fun, 0, pi/2)
        end
    else
        R_ground = (sin(Ang2)-1./Zn)./(sin(Ang2)+1./Zn);
    end
    

%         plot(y(:,ii))
%         hold on
%         plot(y(:,ii+8),'r')
%         xlim([0 1000])
%         pause
%         hold off
       
    %% FFT
    for ii = 1:8*2
               
    if festningsparken == 1
        win1 = [4471 4099 3829 3681 3332 2662 2205 1582];
        win2 = [3500 3389 2762 2308 2351 2329 2119 1723];
        win3 = [4471 3801 3817 3703 3947 3316 2694 1517];
    else        
        win1 = [4471 4099 3829 3681 3332 2662 2205 1582];
        win2 = [3500 3389 2762 2308 2351 2329 2119 1723];
        win3 = [4471 3801 3817 3703 3947 3316 2694 1517];
    end
        % Tidsvindu
        win0 = [4471 4099 3829 3681 3332 2662 2205 1582];
        win90 = [3500 3389 2762 2308 2351 2329 2119 1723];
        win180 = [4471 3801 3817 3703 3947 3316 2694 1517];
   
        eval(['win = win',MM,';']);    
        
        if refl_only == 1
            IR = y(Delay1+150:win(nn),ii);
        else
            IR = y(1:win(nn),ii);  
        end
        
%         IR = y(:,ii);
%         IR = y(1:15000,ii); 

        % FFT
        L1 = length(IR);
        NFFT1 = 2^(nextpow2(L1)+5);

        if ii == 1
            F1 = zeros(length(1:NFFT1/2+1),8*2);
        end    

        F0 = fft(IR, NFFT1)/L1;
        F1(:,ii) = F0(1:NFFT1/2+1);
 
        fvec1 = Fs/2*linspace(0,1,NFFT1/2+1);
    end
    %% Ptrykker direktivitet og refleksjonstap (bakke)
    for ii = 1:8
        if OMNI == 1
            % OMNI
            F1(:,ii)   = F1(:,ii);
            F1(:,ii+8) = F1(:,ii+8) * R_ground(ii);
        else
            % Direk.
            F1(:,ii)   = F1(:,ii)   * 10^(Direc2(ii,1)/20);
            F1(:,ii+8) = F1(:,ii+8) * 10^(Direc3(ii,1)/20) * R_ground(ii);
            
            f1 = F1;
        end
        
    end
    % Summerer direktelyd & refleksjon
    F2 = zeros(length(F1),8);
    L1 = zeros(1,8);
    for ii = 1:8
        F2(:,ii) = (((F1(:,ii) + F1(:,ii+8))));

        if ii == 1
            Lower = zeros(1,8);
            Upper = zeros(1,8);   
        end

        Lower(ii) = round((flower(ii)/(Fs/2))*(NFFT1/2+1));
        Upper(ii) = round((fupper(ii)/(Fs/2))*(NFFT1/2+1));

        L1(:,ii) = 20*log10(mean (abs (F2(Lower(ii):Upper(ii),ii)) ) );

    end
    % Lagre data
    if save_data == 1
        eval(['save(''',MM,'_',NN,'_',R_FLOW,'.mat'', ''L1'');'])
        save('fcenter.mat', 'fcenter')
    end



    %% Plot
    if plot_freq == 1
        F1 = 20*log10(abs(F1)) + 80;
        F2 = 20*log10(abs(F2)) + 80;
        L1 = L1                + 80;

        figure(1)
        semilogx(fvec1,(F1(:,1:8)))
        axis([10 8000 0 60])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title('Direct sound')

        figure(2)
        semilogx(fvec1,(F1(:,9:16)))
        axis([10 8000 0 60])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title('First reflection')

        figure(3)
        semilogx(fvec1, F2)
    %     semilogx(1:length(F2),F2)
        axis([10 8000 30 60])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title('Direct sound & First reflection')

        hold on
        semilogx(fcenter,L1, '--o')
    %     semilogx(Lower,F2(Lower,:), '--o')
    %     semilogx(Upper,F2(Upper,:), '--o')
        hold off
        pause
    %     figure(4)
    %     semilogx(fcenter,F3, '--o')
    %     axis([10 8000 -10 15])
    %     xlabel('Frekvens [Hz]')
    %     ylabel('Magnitude [dB]')
    %     title('Direct sound & First reflection')
    end
    
end
end
end

    if plot_IR == 1
        IR_tot = IR1 + IR2;
        plot(T, IR_tot)
%         axis([40 60 -100 200])
        % axis([40 80 -100 200])
        xlabel('Time [ms]')
        ylabel('Magnitude')
        title('Direct sound & First reflection')
    end

    %% Lukk alt 
    fopen('all');   % Lister alle pne filer
    fclose('all');  % Lukker alle pne filer
    % close all       % Lukker alle plot
    toc