% Serie 1 - 0 grader
% Serie 2 - 90 grader
% Serie 3 - 180 grader
% Serie 4 - Hydevar., 5 m
% Serie 5 - Hydevar., 10 m
% Serie 6 - 90 grader v2

Plot_serie_nr = 3;


read      = 0; % Les data fra .txt, lagre i .mat
load_data = 1; % Les fra .mat

tic
if read == 1
    T = readtable('Metrologidata\serie6.txt','Delimiter',' ');
    T = table2array(T);

    S = zeros(1,6);
    metro = zeros(length(T)-20, 6);

    for ii = 20:length(T)-20
        str = T(20:end,1);
        expression = '\d*';
        numStr = regexp(str,expression,'match');
        s = numStr{ii,1};

            for jj = 1:19
               temp = cell2mat(s(jj));
               S(1,jj) = str2double(temp);
            end

        metro(ii-19,:) = [S(9) S(10)+S(11)*0.1 S(12)+S(13)*0.1 S(14)+S(15)*0.1 ...
            S(16)+S(17)*0.1 S(18)+S(19)*0.1];

    end

% save('serie6.mat', 'metro')
end
toc
if load_data == 1
  m1 = load('serie1.mat');
    m1 = m1.metro;
  m2 = load('serie2.mat');
    m2 = m2.metro;
  m3 = load('serie3.mat');
    m3 = m3.metro;
  m4 = load('serie4.mat');
    m4 = m4.metro;
  m5 = load('serie5.mat');
    m5 = m5.metro;
  m6 = load('serie6.mat');
    m6 = m6.metro;
end

nr = int2str(Plot_serie_nr);
% plot(m5(1:end-30,:))
eval(['m = m',nr,';']);
plot(m)
legend('Vindrettning [Grader]', 'Vindhastighet [m/s]', ['Temperatur [',char(176),'C]'], 'Luftfuktighet [%]','Lufttrykk [HPa]', 'Nedbr [mm]')

[A B] = size(m);
A = A-30;

[AX] = plotyy((1:A)./60, m(1:A,2), (1:A)./60, m(1:A,3));
xlabel('Tid [minutter]')
ylabel(AX(1), 'Vindhastighet [m/s]')
ylabel(AX(2), ['Temperatur [',char(176),'C]'])
set(AX(1), 'YLim', [0 10])
set(AX(1), 'YTick', [0:2:10])
set(AX(2), 'YLim', [9 14])
set(AX(2), 'YTick', [9:1:14])
title(['Mleserie ', nr])
grid on


